#ifndef HMC5883L_H
#define HMC5883L_H

typedef struct { double x, y, z; } hmc5883l_vec3_t;

typedef struct {
  /* Number of samples averaged per reading: */
  enum avg {AVG_1=0, AVG_2=1, AVG_4=2, AVG_8=3} avg;

  /* Load bias direction: */
  enum bias {BIAS_NONE=0, BIAS_POS=1, BIAS_NEG=2} bias;

  /* Gain (in LSb per Gauss): */
  enum gain {GAIN_1370=0, GAIN_1090=1, GAIN_820=2, GAIN_660=3, GAIN_440=4,
   GAIN_390=5, GAIN_330=6, GAIN_230=7} gain;
} hmc5883l_config_t;

extern const hmc5883l_config_t _hmc5883l_config_default;

int hmc5883l_open(void);
int hmc5883l_read(const int fd, hmc5883l_vec3_t * const p,
 const enum gain gain);
int hmc5883l_config(const int fd, const hmc5883l_config_t * const cfg);

#endif /* ifndef HMC5883L_H */
