/* This is free software. See COPYING for details. */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "diag.h"
#include "debug.h"
#include "hmc5883l.h"

int main(void) {
   int fd, i;
   hmc5883l_vec3_t v;
   hmc5883l_config_t cfg;

   memcpy(&cfg, &_hmc5883l_config_default, sizeof(cfg));
   cfg.avg = AVG_8;
   //cfg.gain = GAIN_1370;

   if((fd = hmc5883l_open()) < 0) return -1;
   if(hmc5883l_config(fd, &cfg)) return -1;

   for(i = 0; i < 100000; i++) {
      if(hmc5883l_read(fd, &v, cfg.gain)) return -1;
      printf("%lf %lf %lf\n", v.x, v.y, v.z);
   }

   if(close(fd)) return sysdiag("close", "can't close I2C bus");
   return 0;
}
